/**
 * Copyright (C) 2008-2012 AgroSense Foundation.
 *
 * AgroSense is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * There are special exceptions to the terms and conditions of the GPLv3 as it is applied to
 * this software, see the FLOSS License Exception
 * <http://www.agrosense.eu/foss-exception.html>.
 *
 * AgroSense is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with AgroSense.  If not, see <http://www.gnu.org/licenses/>.
 */
package nl.cloudfarming.client.geoviewer.jxmap.layerlist;

import java.util.ArrayList;
import java.util.List;
import nl.cloudfarming.client.geoviewer.Layer;
import org.openide.nodes.Children;
import org.openide.nodes.FilterNode;
import org.openide.nodes.Node;

/**
 *
 * @author Timon Veenstra
 */
public class FilterLayerListChildren extends FilterNode.Children {

    public FilterLayerListChildren(Node or) {
        super(or);
    }

    @Override
    protected Node[] createNodes(Node object) {
        List<Node> result = new ArrayList<>();
        for (Node node : super.createNodes(object)) {
            if (accept(node)) {
                result.add(new FilterNode(node, Children.LEAF));
            }
        }
        return result.toArray(new Node[0]);
    }

    /**
     * only accept child nodes which have a LayerObject in their lookup
     *
     * @param node
     * @return
     */
    private boolean accept(Node node) {
        return (node.getLookup().lookup(Layer.class) != null);
    }
}
