/**
 * Copyright (C) 2008-2012 AgroSense Foundation.
 *
 * AgroSense is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * There are special exceptions to the terms and conditions of the GPLv3 as it is applied to
 * this software, see the FLOSS License Exception
 * <http://www.agrosense.eu/foss-exception.html>.
 *
 * AgroSense is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with AgroSense.  If not, see <http://www.gnu.org/licenses/>.
 */
package nl.cloudfarming.client.geoviewer.jxmap.map.cache;


/**
 * Transfer object with information about {@link Tile}
 * 
 * @author Frantisek Post
 */
public class TileCacheInfo {
    
    private int zoom;
    private int x;
    private int y;
    private String path;
    
    public TileCacheInfo(int zoom, int x, int y) {
        this.zoom = zoom;
        this.x = x;
        this.y = y;
        path = getFileName(x, y);
    }
    
    private String getFileName(int x, int y) {
        return String.format(CacheUriTranslator.FILE_NAME_FORMAT, x, y);
    }

    public int getX() {
        return x;
    }

    public int getY() {
        return y;
    }

    public int getZoom() {
        return zoom;
    }

    /**
     * returns only filename, without zoom directory.
     * <p>
     * This is because I need to create file with this name and don't want to parse it again to separate directory and filename
     * </p>
     * @return 
     */
    public String getPath() {
        return path;
    }
    
}
